//
//  SMUtil.m
//  KishochoApp
//
//  Created by Cyan K on 06/03/28.
//  cyanworks.net
//

#import "SMUtil.h"

#pragma mark Utilities for string
@implementation NSString (SMString)

- (NSString *)stringByExtractingNumber
{
	NSMutableString		*resultString = [NSMutableString stringWithString:@""];
	NSCharacterSet		*charSet =
		[NSCharacterSet characterSetWithCharactersInString:@"0123456789-/()"];
	unichar		charcter;
	int			i;

	for (i = 0; i < [self length]; i++) {
		charcter = [self characterAtIndex:i];
		if ([charSet characterIsMember:charcter])
			[resultString appendFormat:@"%C", charcter];
	}
	[resultString replaceOccurrencesOfString:@"()" withString:@"" options:0
			range:NSMakeRange(0, [resultString length])];
	[resultString replaceOccurrencesOfString:@"(-)" withString:@"" options:0
			range:NSMakeRange(0, [resultString length])];
	[resultString replaceOccurrencesOfString:@"/" withString:@" " options:0
			range:NSMakeRange(0, [resultString length])];

	if ([resultString length] != 0)
		return [NSString stringWithString:resultString];
	else
		return @"n/a";
}

- (NSString *)stringByDeletingSpaces
{
	NSMutableString		*resultString = [NSMutableString stringWithString:self];
	int		i = 1;

	[resultString replaceOccurrencesOfString:@"\n" withString:@"" options:0
			range:NSMakeRange(0, [resultString length])];
	while (i > 0) {
		i = [resultString replaceOccurrencesOfString:@"  " withString:@" " options:0
			range:NSMakeRange(0, [resultString length])];
	}
	return [NSString stringWithString:resultString];
}

- (NSString *)stringWeatherForCode
{
	NSString	*weatherIcon;
	int			weatherCode = [[self stringByExtractingNumber] intValue];

	switch (weatherCode) {
		case 100:
			weatherIcon = @"fine";
			break;
		case 101:
			weatherIcon = @"fine|cloudy";
			break;
		case 102:
			weatherIcon = @"fine|rain";
			break;
		case 104:
			weatherIcon = @"fine|snow";
			break;
		case 110:
			weatherIcon = @"fine/cloudy";
			break;
		case 112:
			weatherIcon = @"fine/rain";
			break;
		case 115:
			weatherIcon = @"fine/snow";
			break;
		case 200:
			weatherIcon = @"cloudy";
			break;
		case 201:
			weatherIcon = @"cloudy|fine";
			break;
		case 202:
			weatherIcon = @"cloudy|rain";
			break;
		case 204:
			weatherIcon = @"cloudy|snow";
			break;
		case 210:
			weatherIcon = @"cloudy/fine";
			break;
		case 212:
			weatherIcon = @"cloudy/rain";
			break;
		case 215:
			weatherIcon = @"cloudy/snow";
			break;
		case 300:
			weatherIcon = @"rain";
			break;
		case 301:
			weatherIcon = @"rain|fine";
			break;
		case 302:
			weatherIcon = @"rain|cloudy";
			break;
		case 303:
			weatherIcon = @"rain|snow";
			break;
		case 308:
			weatherIcon = @"heavy-rain";
			break;
		case 311:
			weatherIcon = @"rain/fine";
			break;
		case 313:
			weatherIcon = @"rain/cloudy";
			break;
		case 314:
			weatherIcon = @"rain/snow";
			break;
		case 400:
			weatherIcon = @"snow";
			break;
		case 401:
			weatherIcon = @"snow|fine";
			break;
		case 402:
			weatherIcon = @"snow|cloudy";
			break;
		case 403:
			weatherIcon = @"snow|rain";
			break;
		case 406:
			weatherIcon = @"heavy-snow";
			break;
		case 411:
			weatherIcon = @"snow/fine";
			break;
		case 413:
			weatherIcon = @"snow/cloudy";
			break;
		case 414:
			weatherIcon = @"snow/rain";
			break;
		case 700:
			weatherIcon = @"fine night";
			break;
		case 701:
			weatherIcon = @"fine night|cloudy";
			break;
		case 702:
			weatherIcon = @"fine night|rain";
			break;
		case 703:
			weatherIcon = @"fine night|snow";
			break;
		case 704:
			weatherIcon = @"cloudy|fine night";
			break;
		case 705:
			weatherIcon = @"rain|fine night";
			break;
		case 706:
			weatherIcon = @"snow|fine night";
			break;
		case 707:
			weatherIcon = @"fine night/cloudy";
			break;
		case 708:
			weatherIcon = @"fine night/rain";
			break;
		case 709:
			weatherIcon = @"fine night/snow";
			break;
		case 710:
			weatherIcon = @"cloudy/fine night";
			break;
		case 711:
			weatherIcon = @"rain/fine night";
			break;
		case 712:
			weatherIcon = @"snow/fine night";
			break;
		default:
			weatherIcon = @"";
			break;
	}
	return weatherIcon;
}

@end
